// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from caret_msgs:msg/End.idl
// generated code does not contain a copyright notice
#include "caret_msgs/msg/detail/end__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


bool
caret_msgs__msg__End__init(caret_msgs__msg__End * msg)
{
  if (!msg) {
    return false;
  }
  // structure_needs_at_least_one_member
  return true;
}

void
caret_msgs__msg__End__fini(caret_msgs__msg__End * msg)
{
  if (!msg) {
    return;
  }
  // structure_needs_at_least_one_member
}

bool
caret_msgs__msg__End__are_equal(const caret_msgs__msg__End * lhs, const caret_msgs__msg__End * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // structure_needs_at_least_one_member
  if (lhs->structure_needs_at_least_one_member != rhs->structure_needs_at_least_one_member) {
    return false;
  }
  return true;
}

bool
caret_msgs__msg__End__copy(
  const caret_msgs__msg__End * input,
  caret_msgs__msg__End * output)
{
  if (!input || !output) {
    return false;
  }
  // structure_needs_at_least_one_member
  output->structure_needs_at_least_one_member = input->structure_needs_at_least_one_member;
  return true;
}

caret_msgs__msg__End *
caret_msgs__msg__End__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  caret_msgs__msg__End * msg = (caret_msgs__msg__End *)allocator.allocate(sizeof(caret_msgs__msg__End), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(caret_msgs__msg__End));
  bool success = caret_msgs__msg__End__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
caret_msgs__msg__End__destroy(caret_msgs__msg__End * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    caret_msgs__msg__End__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
caret_msgs__msg__End__Sequence__init(caret_msgs__msg__End__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  caret_msgs__msg__End * data = NULL;

  if (size) {
    data = (caret_msgs__msg__End *)allocator.zero_allocate(size, sizeof(caret_msgs__msg__End), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = caret_msgs__msg__End__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        caret_msgs__msg__End__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
caret_msgs__msg__End__Sequence__fini(caret_msgs__msg__End__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      caret_msgs__msg__End__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

caret_msgs__msg__End__Sequence *
caret_msgs__msg__End__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  caret_msgs__msg__End__Sequence * array = (caret_msgs__msg__End__Sequence *)allocator.allocate(sizeof(caret_msgs__msg__End__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = caret_msgs__msg__End__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
caret_msgs__msg__End__Sequence__destroy(caret_msgs__msg__End__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    caret_msgs__msg__End__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
caret_msgs__msg__End__Sequence__are_equal(const caret_msgs__msg__End__Sequence * lhs, const caret_msgs__msg__End__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!caret_msgs__msg__End__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
caret_msgs__msg__End__Sequence__copy(
  const caret_msgs__msg__End__Sequence * input,
  caret_msgs__msg__End__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(caret_msgs__msg__End);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    caret_msgs__msg__End * data =
      (caret_msgs__msg__End *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!caret_msgs__msg__End__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          caret_msgs__msg__End__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!caret_msgs__msg__End__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
