// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from caret_msgs:msg/End.idl
// generated code does not contain a copyright notice

#ifndef CARET_MSGS__MSG__DETAIL__END__FUNCTIONS_H_
#define CARET_MSGS__MSG__DETAIL__END__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "caret_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "caret_msgs/msg/detail/end__struct.h"

/// Initialize msg/End message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * caret_msgs__msg__End
 * )) before or use
 * caret_msgs__msg__End__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_caret_msgs
bool
caret_msgs__msg__End__init(caret_msgs__msg__End * msg);

/// Finalize msg/End message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_caret_msgs
void
caret_msgs__msg__End__fini(caret_msgs__msg__End * msg);

/// Create msg/End message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * caret_msgs__msg__End__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_caret_msgs
caret_msgs__msg__End *
caret_msgs__msg__End__create();

/// Destroy msg/End message.
/**
 * It calls
 * caret_msgs__msg__End__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_caret_msgs
void
caret_msgs__msg__End__destroy(caret_msgs__msg__End * msg);

/// Check for msg/End message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_caret_msgs
bool
caret_msgs__msg__End__are_equal(const caret_msgs__msg__End * lhs, const caret_msgs__msg__End * rhs);

/// Copy a msg/End message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_caret_msgs
bool
caret_msgs__msg__End__copy(
  const caret_msgs__msg__End * input,
  caret_msgs__msg__End * output);

/// Initialize array of msg/End messages.
/**
 * It allocates the memory for the number of elements and calls
 * caret_msgs__msg__End__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_caret_msgs
bool
caret_msgs__msg__End__Sequence__init(caret_msgs__msg__End__Sequence * array, size_t size);

/// Finalize array of msg/End messages.
/**
 * It calls
 * caret_msgs__msg__End__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_caret_msgs
void
caret_msgs__msg__End__Sequence__fini(caret_msgs__msg__End__Sequence * array);

/// Create array of msg/End messages.
/**
 * It allocates the memory for the array and calls
 * caret_msgs__msg__End__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_caret_msgs
caret_msgs__msg__End__Sequence *
caret_msgs__msg__End__Sequence__create(size_t size);

/// Destroy array of msg/End messages.
/**
 * It calls
 * caret_msgs__msg__End__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_caret_msgs
void
caret_msgs__msg__End__Sequence__destroy(caret_msgs__msg__End__Sequence * array);

/// Check for msg/End message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_caret_msgs
bool
caret_msgs__msg__End__Sequence__are_equal(const caret_msgs__msg__End__Sequence * lhs, const caret_msgs__msg__End__Sequence * rhs);

/// Copy an array of msg/End messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_caret_msgs
bool
caret_msgs__msg__End__Sequence__copy(
  const caret_msgs__msg__End__Sequence * input,
  caret_msgs__msg__End__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // CARET_MSGS__MSG__DETAIL__END__FUNCTIONS_H_
