// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from caret_msgs:msg/Start.idl
// generated code does not contain a copyright notice
#include "caret_msgs/msg/detail/start__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `ignore_nodes`
// Member `ignore_topics`
// Member `select_nodes`
// Member `select_topics`
#include "rosidl_runtime_c/string_functions.h"

bool
caret_msgs__msg__Start__init(caret_msgs__msg__Start * msg)
{
  if (!msg) {
    return false;
  }
  // recording_frequency
  msg->recording_frequency = 100ul;
  // ignore_nodes
  if (!rosidl_runtime_c__String__init(&msg->ignore_nodes)) {
    caret_msgs__msg__Start__fini(msg);
    return false;
  }
  // ignore_topics
  if (!rosidl_runtime_c__String__init(&msg->ignore_topics)) {
    caret_msgs__msg__Start__fini(msg);
    return false;
  }
  // select_nodes
  if (!rosidl_runtime_c__String__init(&msg->select_nodes)) {
    caret_msgs__msg__Start__fini(msg);
    return false;
  }
  // select_topics
  if (!rosidl_runtime_c__String__init(&msg->select_topics)) {
    caret_msgs__msg__Start__fini(msg);
    return false;
  }
  return true;
}

void
caret_msgs__msg__Start__fini(caret_msgs__msg__Start * msg)
{
  if (!msg) {
    return;
  }
  // recording_frequency
  // ignore_nodes
  rosidl_runtime_c__String__fini(&msg->ignore_nodes);
  // ignore_topics
  rosidl_runtime_c__String__fini(&msg->ignore_topics);
  // select_nodes
  rosidl_runtime_c__String__fini(&msg->select_nodes);
  // select_topics
  rosidl_runtime_c__String__fini(&msg->select_topics);
}

bool
caret_msgs__msg__Start__are_equal(const caret_msgs__msg__Start * lhs, const caret_msgs__msg__Start * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // recording_frequency
  if (lhs->recording_frequency != rhs->recording_frequency) {
    return false;
  }
  // ignore_nodes
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->ignore_nodes), &(rhs->ignore_nodes)))
  {
    return false;
  }
  // ignore_topics
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->ignore_topics), &(rhs->ignore_topics)))
  {
    return false;
  }
  // select_nodes
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->select_nodes), &(rhs->select_nodes)))
  {
    return false;
  }
  // select_topics
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->select_topics), &(rhs->select_topics)))
  {
    return false;
  }
  return true;
}

bool
caret_msgs__msg__Start__copy(
  const caret_msgs__msg__Start * input,
  caret_msgs__msg__Start * output)
{
  if (!input || !output) {
    return false;
  }
  // recording_frequency
  output->recording_frequency = input->recording_frequency;
  // ignore_nodes
  if (!rosidl_runtime_c__String__copy(
      &(input->ignore_nodes), &(output->ignore_nodes)))
  {
    return false;
  }
  // ignore_topics
  if (!rosidl_runtime_c__String__copy(
      &(input->ignore_topics), &(output->ignore_topics)))
  {
    return false;
  }
  // select_nodes
  if (!rosidl_runtime_c__String__copy(
      &(input->select_nodes), &(output->select_nodes)))
  {
    return false;
  }
  // select_topics
  if (!rosidl_runtime_c__String__copy(
      &(input->select_topics), &(output->select_topics)))
  {
    return false;
  }
  return true;
}

caret_msgs__msg__Start *
caret_msgs__msg__Start__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  caret_msgs__msg__Start * msg = (caret_msgs__msg__Start *)allocator.allocate(sizeof(caret_msgs__msg__Start), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(caret_msgs__msg__Start));
  bool success = caret_msgs__msg__Start__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
caret_msgs__msg__Start__destroy(caret_msgs__msg__Start * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    caret_msgs__msg__Start__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
caret_msgs__msg__Start__Sequence__init(caret_msgs__msg__Start__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  caret_msgs__msg__Start * data = NULL;

  if (size) {
    data = (caret_msgs__msg__Start *)allocator.zero_allocate(size, sizeof(caret_msgs__msg__Start), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = caret_msgs__msg__Start__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        caret_msgs__msg__Start__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
caret_msgs__msg__Start__Sequence__fini(caret_msgs__msg__Start__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      caret_msgs__msg__Start__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

caret_msgs__msg__Start__Sequence *
caret_msgs__msg__Start__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  caret_msgs__msg__Start__Sequence * array = (caret_msgs__msg__Start__Sequence *)allocator.allocate(sizeof(caret_msgs__msg__Start__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = caret_msgs__msg__Start__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
caret_msgs__msg__Start__Sequence__destroy(caret_msgs__msg__Start__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    caret_msgs__msg__Start__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
caret_msgs__msg__Start__Sequence__are_equal(const caret_msgs__msg__Start__Sequence * lhs, const caret_msgs__msg__Start__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!caret_msgs__msg__Start__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
caret_msgs__msg__Start__Sequence__copy(
  const caret_msgs__msg__Start__Sequence * input,
  caret_msgs__msg__Start__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(caret_msgs__msg__Start);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    caret_msgs__msg__Start * data =
      (caret_msgs__msg__Start *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!caret_msgs__msg__Start__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          caret_msgs__msg__Start__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!caret_msgs__msg__Start__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
