// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from caret_msgs:msg/Start.idl
// generated code does not contain a copyright notice

#ifndef CARET_MSGS__MSG__DETAIL__START__STRUCT_HPP_
#define CARET_MSGS__MSG__DETAIL__START__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__caret_msgs__msg__Start __attribute__((deprecated))
#else
# define DEPRECATED__caret_msgs__msg__Start __declspec(deprecated)
#endif

namespace caret_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Start_
{
  using Type = Start_<ContainerAllocator>;

  explicit Start_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::DEFAULTS_ONLY == _init)
    {
      this->recording_frequency = 100ul;
    } else if (rosidl_runtime_cpp::MessageInitialization::ZERO == _init) {
      this->recording_frequency = 0ul;
      this->ignore_nodes = "";
      this->ignore_topics = "";
      this->select_nodes = "";
      this->select_topics = "";
    }
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->ignore_nodes = "";
      this->ignore_topics = "";
      this->select_nodes = "";
      this->select_topics = "";
    }
  }

  explicit Start_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : ignore_nodes(_alloc),
    ignore_topics(_alloc),
    select_nodes(_alloc),
    select_topics(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::DEFAULTS_ONLY == _init)
    {
      this->recording_frequency = 100ul;
    } else if (rosidl_runtime_cpp::MessageInitialization::ZERO == _init) {
      this->recording_frequency = 0ul;
      this->ignore_nodes = "";
      this->ignore_topics = "";
      this->select_nodes = "";
      this->select_topics = "";
    }
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->ignore_nodes = "";
      this->ignore_topics = "";
      this->select_nodes = "";
      this->select_topics = "";
    }
  }

  // field types and members
  using _recording_frequency_type =
    uint32_t;
  _recording_frequency_type recording_frequency;
  using _ignore_nodes_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _ignore_nodes_type ignore_nodes;
  using _ignore_topics_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _ignore_topics_type ignore_topics;
  using _select_nodes_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _select_nodes_type select_nodes;
  using _select_topics_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _select_topics_type select_topics;

  // setters for named parameter idiom
  Type & set__recording_frequency(
    const uint32_t & _arg)
  {
    this->recording_frequency = _arg;
    return *this;
  }
  Type & set__ignore_nodes(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->ignore_nodes = _arg;
    return *this;
  }
  Type & set__ignore_topics(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->ignore_topics = _arg;
    return *this;
  }
  Type & set__select_nodes(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->select_nodes = _arg;
    return *this;
  }
  Type & set__select_topics(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->select_topics = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    caret_msgs::msg::Start_<ContainerAllocator> *;
  using ConstRawPtr =
    const caret_msgs::msg::Start_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<caret_msgs::msg::Start_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<caret_msgs::msg::Start_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      caret_msgs::msg::Start_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<caret_msgs::msg::Start_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      caret_msgs::msg::Start_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<caret_msgs::msg::Start_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<caret_msgs::msg::Start_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<caret_msgs::msg::Start_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__caret_msgs__msg__Start
    std::shared_ptr<caret_msgs::msg::Start_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__caret_msgs__msg__Start
    std::shared_ptr<caret_msgs::msg::Start_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Start_ & other) const
  {
    if (this->recording_frequency != other.recording_frequency) {
      return false;
    }
    if (this->ignore_nodes != other.ignore_nodes) {
      return false;
    }
    if (this->ignore_topics != other.ignore_topics) {
      return false;
    }
    if (this->select_nodes != other.select_nodes) {
      return false;
    }
    if (this->select_topics != other.select_topics) {
      return false;
    }
    return true;
  }
  bool operator!=(const Start_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Start_

// alias to use template instance with default allocator
using Start =
  caret_msgs::msg::Start_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace caret_msgs

#endif  // CARET_MSGS__MSG__DETAIL__START__STRUCT_HPP_
